searchData={"items":[{"type":"module","title":"LazyDoc","doc":"","ref":"LazyDoc.html"},{"type":"module","title":"Main functionality - LazyDoc","doc":"The module LazyDoc provides a way to extract and organize documentation from Elixir source files by reading them, parsing their abstract syntax tree (AST), and collecting relevant information about modules, functions, and comments.","ref":"LazyDoc.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc","doc":"It implements functions to read files matching a given path pattern, extract their AST and comments, group function definitions by names and arities, filter out undocumented functions and modules, and retrieve associated documentation for the extracted modules. The module serves as a utility for generating or managing documentation for Elixir projects.","ref":"LazyDoc.html#module-description"},{"type":"function","title":"LazyDoc.docs_per_module/1","doc":"Returns a list of documentation for each function in the specified modules.","ref":"LazyDoc.html#docs_per_module/1"},{"type":"function","title":"Parameters - LazyDoc.docs_per_module/1","doc":"- modules - a list of module names to extract documentation from.","ref":"LazyDoc.html#docs_per_module/1-parameters"},{"type":"function","title":"Description - LazyDoc.docs_per_module/1","doc":"Retrieves the documentation for functions in the given modules using Elixir's introspection capabilities.","ref":"LazyDoc.html#docs_per_module/1-description"},{"type":"function","title":"LazyDoc.extract_data_from_files/0","doc":"Returns the extracted data from files, including AST and documented functions.","ref":"LazyDoc.html#extract_data_from_files/0"},{"type":"function","title":"Parameters - LazyDoc.extract_data_from_files/0","doc":"- None","ref":"LazyDoc.html#extract_data_from_files/0-parameters"},{"type":"function","title":"Description - LazyDoc.extract_data_from_files/0","doc":"Processes files matching specified patterns and extracts their content, abstracts syntax tree, and documentation.","ref":"LazyDoc.html#extract_data_from_files/0-description"},{"type":"function","title":"LazyDoc.extract_names/1","doc":"Returns a list of names extracted from the given AST (Abstract Syntax Tree).","ref":"LazyDoc.html#extract_names/1"},{"type":"function","title":"Parameters - LazyDoc.extract_names/1","doc":"- ast - the AST to be traversed for extracting names.","ref":"LazyDoc.html#extract_names/1-parameters"},{"type":"function","title":"Description - LazyDoc.extract_names/1","doc":"Traverses the AST and accumulates names of modules, protocols, and functions, returning them in a structured format.","ref":"LazyDoc.html#extract_names/1-description"},{"type":"function","title":"LazyDoc.filter_documented_functions/2","doc":"Returns the filtered list of functions that are documented and visible.","ref":"LazyDoc.html#filter_documented_functions/2"},{"type":"function","title":"Parameters - LazyDoc.filter_documented_functions/2","doc":"- module - the module from which functions are being filtered.\n- module_ast - the abstract syntax tree of the module.\n- _code_mod - additional code modifications.\n- functions - the list of functions to be filtered.","ref":"LazyDoc.html#filter_documented_functions/2-parameters"},{"type":"function","title":"Description - LazyDoc.filter_documented_functions/2","doc":"Filters the functions based on their documentation status.","ref":"LazyDoc.html#filter_documented_functions/2-description"},{"type":"function","title":"LazyDoc.filter_undocumented_functions/2","doc":"Returns a tuple containing the module, module AST, and a list of undocumented functions filtered from the input.","ref":"LazyDoc.html#filter_undocumented_functions/2"},{"type":"function","title":"Parameters - LazyDoc.filter_undocumented_functions/2","doc":"- module - the module name for which undocumented functions are being filtered.\n- module_ast - the abstract syntax tree representation of the module.\n- _code_mod - unused code modification parameter.\n- functions - a list of functions in the module, where each function is represented as a tuple with its type and name.","ref":"LazyDoc.html#filter_undocumented_functions/2-parameters"},{"type":"function","title":"Description - LazyDoc.filter_undocumented_functions/2","doc":"Filters the provided list of functions to retain only those that are undocumented.","ref":"LazyDoc.html#filter_undocumented_functions/2-description"},{"type":"function","title":"LazyDoc.filter_undocumented_modules/1","doc":"Returns a list of undocumented modules from the provided input.","ref":"LazyDoc.html#filter_undocumented_modules/1"},{"type":"function","title":"Parameters - LazyDoc.filter_undocumented_modules/1","doc":"- zip_to_process - a collection of modules and their associated documentation status.","ref":"LazyDoc.html#filter_undocumented_modules/1-parameters"},{"type":"function","title":"Description - LazyDoc.filter_undocumented_modules/1","doc":"Filters through the provided modules to identify those without documentation and returns their details.","ref":"LazyDoc.html#filter_undocumented_modules/1-description"},{"type":"function","title":"LazyDoc.group_docs_different_arities/1","doc":"Returns a map grouping function documentation by function name.","ref":"LazyDoc.html#group_docs_different_arities/1"},{"type":"function","title":"Parameters - LazyDoc.group_docs_different_arities/1","doc":"- func_docs - a list of function documentation tuples.","ref":"LazyDoc.html#group_docs_different_arities/1-parameters"},{"type":"function","title":"Description - LazyDoc.group_docs_different_arities/1","doc":"Groups the provided function documentation by their respective function names.","ref":"LazyDoc.html#group_docs_different_arities/1-description"},{"type":"function","title":"LazyDoc.join_code_from_clauses/1","doc":"Returns a list of join codes derived from the given names.","ref":"LazyDoc.html#join_code_from_clauses/1"},{"type":"function","title":"Parameters - LazyDoc.join_code_from_clauses/1","doc":"- names - a list of tuples where each tuple contains a type and a tuple of a name and a code.","ref":"LazyDoc.html#join_code_from_clauses/1-parameters"},{"type":"function","title":"Description - LazyDoc.join_code_from_clauses/1","doc":"Processes the input list to merge codes based on matching names, creating a comprehensive output.","ref":"LazyDoc.html#join_code_from_clauses/1-description"},{"type":"module","title":"LazyDoc.Application","doc":"","ref":"LazyDoc.Application.html"},{"type":"module","title":"Main functionality - LazyDoc.Application","doc":"The module LazyDoc.Application is responsible for initiating the application process in the LazyDoc system.","ref":"LazyDoc.Application.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Application","doc":"It provides a start function that allows for the initiation of application processes with specified start parameters. The function returns the process identifier of the newly started process, which can be utilized for further interactions within the application.","ref":"LazyDoc.Application.html#module-description"},{"type":"function","title":"LazyDoc.Application.start/2","doc":"Returns an atom indicating the status of the start operation.","ref":"LazyDoc.Application.html#start/2"},{"type":"function","title":"Parameters - LazyDoc.Application.start/2","doc":"- _start_type - a variable representing the type of the start operation.\n- _start_args - a variable containing additional arguments for the start operation.","ref":"LazyDoc.Application.html#start/2-parameters"},{"type":"function","title":"Description - LazyDoc.Application.start/2","doc":"Initiates the start process and returns the PID of the current process.","ref":"LazyDoc.Application.html#start/2-description"},{"type":"module","title":"LazyDoc.Example","doc":"Documentation for `LazyDoc`.\n\nThis module is an example of autogenerated docs by\nthe task provided.","ref":"LazyDoc.Example.html"},{"type":"function","title":"LazyDoc.Example.func_without_doc/0","doc":"Returns a message indicating a greeting.","ref":"LazyDoc.Example.html#func_without_doc/0"},{"type":"function","title":"Parameters - LazyDoc.Example.func_without_doc/0","doc":"- None","ref":"LazyDoc.Example.html#func_without_doc/0-parameters"},{"type":"function","title":"Description - LazyDoc.Example.func_without_doc/0","doc":"Executes a print statement to display \"Hello world\".","ref":"LazyDoc.Example.html#func_without_doc/0-description"},{"type":"function","title":"LazyDoc.Example.hello/0","doc":"Returns the atom :world.","ref":"LazyDoc.Example.html#hello/0"},{"type":"function","title":"Parameters - LazyDoc.Example.hello/0","doc":"- None","ref":"LazyDoc.Example.html#hello/0-parameters"},{"type":"function","title":"Description - LazyDoc.Example.hello/0","doc":"Returns a predefined atom value.","ref":"LazyDoc.Example.html#hello/0-description"},{"type":"function","title":"LazyDoc.Example.my_func/1","doc":"Returns a description based on the input value.","ref":"LazyDoc.Example.html#my_func/1"},{"type":"function","title":"Parameters - LazyDoc.Example.my_func/1","doc":"- n - The input number to be described.","ref":"LazyDoc.Example.html#my_func/1-parameters"},{"type":"function","title":"Description - LazyDoc.Example.my_func/1","doc":"Generates a string representation of the input number.","ref":"LazyDoc.Example.html#my_func/1-description"},{"type":"function","title":"LazyDoc.Example.my_func_2/1","doc":"Returns the string representation of the input number.","ref":"LazyDoc.Example.html#my_func_2/1"},{"type":"function","title":"Parameters - LazyDoc.Example.my_func_2/1","doc":"- n - an integer value.","ref":"LazyDoc.Example.html#my_func_2/1-parameters"},{"type":"function","title":"Description - LazyDoc.Example.my_func_2/1","doc":"Returns a string indicating the value of n.","ref":"LazyDoc.Example.html#my_func_2/1-description"},{"type":"behaviour","title":"LazyDoc.Provider","doc":"","ref":"LazyDoc.Provider.html"},{"type":"behaviour","title":"Main functionality - LazyDoc.Provider","doc":"The module LazyDoc.Provider provides a standard interface for making requests to an external service and processing the responses.","ref":"LazyDoc.Provider.html#module-main-functionality"},{"type":"behaviour","title":"Description - LazyDoc.Provider","doc":"It defines a set of callbacks and functions that allow a user to request a prompt, retrieve documents from a response, and interact with models, enabling flexible integration with various providers that conform to this interface.","ref":"LazyDoc.Provider.html#module-description"},{"type":"callback","title":"LazyDoc.Provider.check_parameters?/1","doc":"","ref":"LazyDoc.Provider.html#c:check_parameters?/1"},{"type":"function","title":"LazyDoc.Provider.check_parameters?/2","doc":"Returns whether the parameters are valid according to the given callback module.","ref":"LazyDoc.Provider.html#check_parameters?/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.check_parameters?/2","doc":"- callback_module - the module that contains the check_parameters? method to validate the parameters.\n- params - the parameters to be validated against the callback module's method.","ref":"LazyDoc.Provider.html#check_parameters?/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.check_parameters?/2","doc":"Invokes the check_parameters? method on the specified callback module to verify the validity of the provided parameters.","ref":"LazyDoc.Provider.html#check_parameters?/2-description"},{"type":"callback","title":"LazyDoc.Provider.get_docs_from_response/1","doc":"","ref":"LazyDoc.Provider.html#c:get_docs_from_response/1"},{"type":"function","title":"LazyDoc.Provider.get_docs_from_response/2","doc":"Returns the documents extracted from the response using the specified callback module.","ref":"LazyDoc.Provider.html#get_docs_from_response/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.get_docs_from_response/2","doc":"- callback_module - the module responsible for handling the response and extracting the documents.\n- response - the data response from which documents need to be extracted.","ref":"LazyDoc.Provider.html#get_docs_from_response/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.get_docs_from_response/2","doc":"Calls the method get_docs_from_response in the provided callback module to process the response.","ref":"LazyDoc.Provider.html#get_docs_from_response/2-description"},{"type":"callback","title":"LazyDoc.Provider.model/1","doc":"","ref":"LazyDoc.Provider.html#c:model/1"},{"type":"function","title":"LazyDoc.Provider.model/2","doc":"Returns the result of invoking the model method on the specified callback module with the given model.","ref":"LazyDoc.Provider.html#model/2"},{"type":"function","title":"Parameters - LazyDoc.Provider.model/2","doc":"- callback_module - the module that contains the model method.\n- model - the data structure or object to be processed by the model method.","ref":"LazyDoc.Provider.html#model/2-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.model/2","doc":"Invokes the model method from the provided callback module with the specified model argument.","ref":"LazyDoc.Provider.html#model/2-description"},{"type":"callback","title":"LazyDoc.Provider.request_prompt/4","doc":"","ref":"LazyDoc.Provider.html#c:request_prompt/4"},{"type":"function","title":"LazyDoc.Provider.request_prompt/5","doc":"Returns the result of the request prompt operation initiated with the provided parameters.","ref":"LazyDoc.Provider.html#request_prompt/5"},{"type":"function","title":"Parameters - LazyDoc.Provider.request_prompt/5","doc":"- callback_module - The module used to handle the request.\n- prompt - The prompt that will be processed by the model.\n- model - The model that will be utilized for generating the response.\n- token - An authorization token for the request.\n- params - Optional additional parameters for the request.","ref":"LazyDoc.Provider.html#request_prompt/5-parameters"},{"type":"function","title":"Description - LazyDoc.Provider.request_prompt/5","doc":"Executes a request through the specified callback module using the given prompt and model.","ref":"LazyDoc.Provider.html#request_prompt/5-description"},{"type":"module","title":"LazyDoc.Providers.GithubAi","doc":"","ref":"LazyDoc.Providers.GithubAi.html"},{"type":"module","title":"Main functionality - LazyDoc.Providers.GithubAi","doc":"The module LazyDoc.Providers.GithubAi provides a way of interacting with the Github AI API for prompt-based communication and response generation.","ref":"LazyDoc.Providers.GithubAi.html#module-main-functionality"},{"type":"module","title":"Description - LazyDoc.Providers.GithubAi","doc":"It implements the behavior Provider, offering a standardized method to request and retrieve responses from AI models hosted on the Github AI platform. Key operations include sending prompts, constructing API requests, and processing responses.","ref":"LazyDoc.Providers.GithubAi.html#module-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"Returns a boolean indicating whether all provided parameters are valid.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"- params - a list of key-value pairs representing parameters to be checked.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.check_parameters?/1","doc":"Validates the parameters against a predefined list of acceptable keys.","ref":"LazyDoc.Providers.GithubAi.html#check_parameters?/1-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"Returns the content of the message from the response.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"- response - a `%Req.Response{}` struct containing the body of the response which includes the message.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.get_docs_from_response/1","doc":"Extracts the message content from the response body.","ref":"LazyDoc.Providers.GithubAi.html#get_docs_from_response/1-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.model/1","doc":"Returns the corresponding model name based on the provided model symbol.","ref":"LazyDoc.Providers.GithubAi.html#model/1"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.model/1","doc":"- model - symbol representing the model type (:codestral, :gpt_4o, or :gpt_4o_mini).","ref":"LazyDoc.Providers.GithubAi.html#model/1-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.model/1","doc":"Returns the name of the model as a string based on the input symbol.","ref":"LazyDoc.Providers.GithubAi.html#model/1-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.req_query/4","doc":"Returns a request configuration for querying a model with the specified parameters.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.req_query/4","doc":"- prompt - The input text that will guide the model's response.\n- model - The identifier of the model to use for generating the output.\n- token - The authentication token for accessing the model's API.\n- params - Optional parameters such as temperature, top_p, and max_tokens to fine-tune the model's output.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.req_query/4","doc":"Constructs a request to the model API with specified settings and configurations.","ref":"LazyDoc.Providers.GithubAi.html#req_query/4-description"},{"type":"function","title":"LazyDoc.Providers.GithubAi.request_prompt/4","doc":"Returns the result of a request made with a prompt using a specified model and token.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4"},{"type":"function","title":"Parameters - LazyDoc.Providers.GithubAi.request_prompt/4","doc":"- prompt - The input text or question to be sent in the request.\n- model - The model that will process the input prompt.\n- token - The authentication token required to access the request.\n- params - Optional parameters for customizing the request.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4-parameters"},{"type":"function","title":"Description - LazyDoc.Providers.GithubAi.request_prompt/4","doc":"Performs a request to the API with the provided prompt and model.","ref":"LazyDoc.Providers.GithubAi.html#request_prompt/4-description"},{"type":"task","title":"mix lazy_doc","doc":"","ref":"Mix.Tasks.LazyDoc.html"},{"type":"task","title":"Main functionality - mix lazy_doc","doc":"The module Mix.Tasks.LazyDoc provides a Mix task for processing source files to extract and format documentation for Elixir modules and functions.","ref":"Mix.Tasks.LazyDoc.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc","doc":"It enables the extraction of documentation using AI to enhance the documentation generation process, verifying and formatting documentation as per specified requirements. It handles reading the source code, interacting with a provider for documentation prompts, and writing the results back in a structured format.","ref":"Mix.Tasks.LazyDoc.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"Returns true if the provided docs are formatted correctly according to the specified criteria.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"- docs - a binary string containing the documentation text to be validated.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.docs_are_ok?/1","doc":"Checks if the documentation is correctly formatted with either a single line or a multi-line block.","ref":"Mix.Tasks.LazyDoc.html#docs_are_ok?/1-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"Returns the modified Abstract Syntax Tree (AST) corresponding to the documentation provided.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"- docs - the documentation string to be converted into an AST.\n- acc_ast - the accumulator AST that will be updated.\n- module_ast - the AST of the module where the documentation will be inserted.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.docs_to_module_doc_node/3","doc":"Converts a documentation string into an Elixir AST and integrates it into the module's AST.","ref":"Mix.Tasks.LazyDoc.html#docs_to_module_doc_node/3-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"Returns the updated AST after inserting the documentation for the specified function.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"- ast - the abstract syntax tree of the module.\n- name_func - the name of the function for which documentation is being added.\n- ast_doc - the documentation to be inserted into the function.\n- module_ast - the abstract syntax tree representation of the module.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_doc_for_function/4","doc":"Traverses the AST and inserts documentation for the specified function within the specified module.","ref":"Mix.Tasks.LazyDoc.html#insert_doc_for_function/4-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"Returns the modified AST with the documentation for the specified module inserted.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"- ast - the abstract syntax tree representing the original code.\n- module_ast - the abstract syntax tree of the module where documentation is to be inserted.\n- ast_doc - the documentation to be inserted into the module's AST.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_module_doc/3","doc":"Modifies the module's AST to include documentation by traversing the original AST.","ref":"Mix.Tasks.LazyDoc.html#insert_module_doc/3-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"Returns the updated abstract syntax tree after inserting documentation nodes for specified functions in the given module.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"- module - atom representing the module name.\n- module_ast - the abstract syntax tree of the module.\n- functions - a list of functions for which documentation needs to be inserted.\n- final_prompt - the final prompt to use for generating documentation.\n- provider_mod - the module responsible for making the request to the provider.\n- model_text - the text model to be used in the request.\n- token - authentication token for the provider.\n- params - additional parameters for the request.\n- acc - an accumulator that holds the current state of the abstract syntax tree.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.insert_nodes_in_module/7","doc":"Handles the insertion of documentation nodes by leveraging an external documentation provider and integrates the results into the module's AST.","ref":"Mix.Tasks.LazyDoc.html#insert_nodes_in_module/7-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.proccess_files/1","doc":"Returns the processed files based on the provided entries.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.proccess_files/1","doc":"- entries - a list of entries containing module and function information.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.proccess_files/1","doc":"Processes each entry, generating documentation and writing it to the respective files.","ref":"Mix.Tasks.LazyDoc.html#proccess_files/1-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.run/1","doc":"Returns the result of starting necessary applications and processing files based on the provided command line arguments.","ref":"Mix.Tasks.LazyDoc.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.run/1","doc":"- _command_line_args - the command line arguments provided to the application.","ref":"Mix.Tasks.LazyDoc.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.run/1","doc":"Initiates the required applications and processes the files accordingly.","ref":"Mix.Tasks.LazyDoc.html#run/1-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file/2","doc":"Returns the result of writing the abstract syntax tree (AST) to a specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.write_to_file/2","doc":"- file - the path to the file where the AST will be written.\n- ast - the abstract syntax tree that will be converted to a string and written to the file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.write_to_file/2","doc":"Writes the string representation of the given AST to the specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file/2-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"Writes the formatted contents of an AST and comments to a specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"- file - the name of the file where the formatted output will be written.\n- ast - the abstract syntax tree that needs to be formatted.\n- comments - any comments that should accompany the formatted AST.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.write_to_file_formatted/3","doc":"Formats the AST and comments as a string and writes it to the specified file.","ref":"Mix.Tasks.LazyDoc.html#write_to_file_formatted/3-description"},{"type":"task","title":"mix lazy_doc.check","doc":"","ref":"Mix.Tasks.LazyDoc.Check.html"},{"type":"task","title":"Main functionality - mix lazy_doc.check","doc":"The module Mix.Tasks.LazyDoc.Check is designed to facilitate the checking of documentation for functions and modules within a codebase using the LazyDoc application.","ref":"Mix.Tasks.LazyDoc.Check.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc.check","doc":"It initializes the LazyDoc application, identifies undocumented functions and modules across specified files, and exits with an appropriate status code based on the presence of undocumented elements. Warnings are logged for any undocumented functions and modules encountered during the check.","ref":"Mix.Tasks.LazyDoc.Check.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"Returns a list of modules that contain undocumented functions.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"- entry_functions - a list of tuples containing module information and their respective function ASTs.\n- file - the file name where the functions are being analyzed.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_functions/2","doc":"Iterates over the entry functions and prints warnings for undocumented functions.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_functions/2-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"Returns true if undocumented modules are found; otherwise, it returns false.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"- modules - a list of modules to check for documentation.\n- file - the name of the file being analyzed for undocumented modules.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.get_undocumented_modules/2","doc":"Logs warnings for each undocumented module along with the associated file name.","ref":"Mix.Tasks.LazyDoc.Check.html#get_undocumented_modules/2-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"Returns a warning log for undocumented functions in a specified module.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"- functions - a list of functions to check for documentation status.\n- mod - the module where the functions are defined.\n- file - the name of the file containing the module.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.print_warnings/3","doc":"Logs warnings for each undocumented function and information about the file.","ref":"Mix.Tasks.LazyDoc.Check.html#print_warnings/3-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Check.run/1","doc":"Returns the exit status of the application based on the presence of undocumented functions or modules.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Check.run/1","doc":"- _command_line_args - the command line arguments passed to the function.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Check.run/1","doc":"Initializes the application, runs the Mix task for configuration, and checks for undocumented functions and modules in extracted data.","ref":"Mix.Tasks.LazyDoc.Check.html#run/1-description"},{"type":"task","title":"mix lazy_doc.clean","doc":"","ref":"Mix.Tasks.LazyDoc.Clean.html"},{"type":"task","title":"Main functionality - mix lazy_doc.clean","doc":"The module Mix.Tasks.LazyDoc.Clean provides a task for cleaning up documentation in the codebase.","ref":"Mix.Tasks.LazyDoc.Clean.html#module-main-functionality"},{"type":"task","title":"Description - mix lazy_doc.clean","doc":"It implements functionality for removing documentation for specific functions from the abstract syntax tree (AST) of Elixir modules. The task starts the LazyDoc application, checks the application configuration, extracts documentation data from files, and processes each entry to remove the documentation for specified functions, updating the files accordingly.","ref":"Mix.Tasks.LazyDoc.Clean.html#module-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"Returns a boolean indicating whether the working directory is clean.","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"- None","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.clean_tree?/0","doc":"Executes a system command to check for differences in the working directory.","ref":"Mix.Tasks.LazyDoc.Clean.html#clean_tree?/0-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"Returns the updated AST after removing the specified function definition from the given module.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"- ast - the original abstract syntax tree (AST) of the module.\n- module_ast - the AST representation of the target module.\n- name_func - the name of the function to be deleted from the AST.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.delete_doc_from_ast/3","doc":"Traverses the AST to locate and remove a specified function definition from a given module's AST.","ref":"Mix.Tasks.LazyDoc.Clean.html#delete_doc_from_ast/3-description"},{"type":"function","title":"Mix.Tasks.LazyDoc.Clean.run/1","doc":"Returns the result of executing the _command_line_args through the LazyDoc application.","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1"},{"type":"function","title":"Parameters - Mix.Tasks.LazyDoc.Clean.run/1","doc":"- _command_line_args - command line arguments to be processed by the function.","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1-parameters"},{"type":"function","title":"Description - Mix.Tasks.LazyDoc.Clean.run/1","doc":"Handles the execution logic for documenting files and managing application configurations.","ref":"Mix.Tasks.LazyDoc.Clean.html#run/1-description"},{"type":"extras","title":"LazyDoc","doc":"# LazyDoc\n\nLazy Doc is a project for those who are lazy af to document their code.\n\nIt is designed to detect undocumented functions, pass the function to an AI\nprovider which is a tuple of two elements `{GithubAi, :codestral}`.","ref":"readme.html"},{"type":"extras","title":"Installation - LazyDoc","doc":"``` elixir\ndef deps do\n  [\n    {:lazy_doc, \"~> 0.5.3\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - LazyDoc","doc":"`config/config.exs`\n\n``` elixir","ref":"readme.html#configuration"},{"type":"extras","title":"alias of GithubAi above - LazyDoc","doc":"import Config\nalias LazyDoc.Providers.GithubAi","ref":"readme.html#alias-of-githubai-above"},{"type":"extras","title":"configure formatter. - LazyDoc","doc":"config :lazy_doc,\n  patterns: [\n   ~r\"^lib/[a-zA-Z_]+(?:/[a-zA-Z_]+)*/[a-zA-Z_]+\\.ex$\",\n  ],\n  max_retries: 3,\n  receive_timeout: 15_000,\n  file_formatter: \".formatter.exs\",\n  provider: {GithubAi, :gpt_4o_mini, [max_tokens: 2048, top_p: 1, temperature: 1]},\n  custom_function_prompt:\n    ~s(You should describe the parameters based on the spec given and give a small description of the following function.\\n\\nPlease do it in the following format given as an example, important do not return the header of the function, do not return a explanation of the function, your output must be only the docs in the following format.\\n\\n@doc \"\"\"\\n\\n","ref":"readme.html#configure-formatter"},{"type":"extras","title":"Parameters\\n\\n- transaction_id - foreign key of the Transactions table.\\n## Description\\n Performs a search in the database\\n\\n## Returns\\n the Transaction corresponding to transaction_id\\n\\n\"\"\"\\n\\nFunction to document:\\n), - LazyDoc","doc":"custom_module_prompt:\n    ~s(You should describe what this module does based on the code given.\\n\\n Please do it in the following format given as an example, important do not return the code of the module, your output must be only the docs in the following format.\\n\\n@moduledoc \"\"\"\\n\\n","ref":"readme.html#parameters-n-n-transaction_id-foreign-key-of-the-transactions-table-n-description-n-performs-a-search-in-the-database-n-n-returns-n-the-transaction-corresponding-to-transaction_id-n-n-n-nfunction-to-document-n"},{"type":"extras","title":"Main functionality\\n\\n The module GithubAi provides a way of communicating with Github AI API.\\n\\n ## Description\\n\\n It implements the behavior Provider a standard way to use a provider in LazyDoc.\\n\"\"\"\\n\\nModule to document:\\n) - LazyDoc","doc":"```\n\n`config/runtime.exs`\n\n``` elixir\nconfig :lazy_doc, :token, System.get_env(\"API_TOKEN\")\n```\n\n`.env`\n\n``` bash\nAPI_TOKEN=\"YOUR AWESOME TOKEN\"\n```","ref":"readme.html#main-functionality-n-n-the-module-githubai-provides-a-way-of-communicating-with-github-ai-api-n-n-description-n-n-it-implements-the-behavior-provider-a-standard-way-to-use-a-provider-in-lazydoc-n-n-nmodule-to-document-n"},{"type":"extras","title":"How to run it ? - LazyDoc","doc":"From the root of the elixir project once installed and configured.\n\n``` bash\nmix lazy_doc\n```\n\nI would recommend to run a `mix format` after just in case.\n\nIf you want, you can add a simple check to see what needs to be documented in\nyour project. This is good for CI.\n\n``` bash\nmix lazy_doc.check\n```","ref":"readme.html#how-to-run-it"},{"type":"extras","title":"Known limitations that wont be fixed. - LazyDoc","doc":"","ref":"readme.html#known-limitations-that-wont-be-fixed"},{"type":"extras","title":"Module names in the same file must be different. - LazyDoc","doc":"If the user creates an inner module with the same name as the parent module\n`lazy_doc`, it wont work properly because they have the same `:__aliases__` AST\nnode.\n\n> Note: this limitation it is only in module names. So if the user have same\n> names of functions in different modules or in the same module, it will work.\n\n``` elixir\n\ndefmodule Hello do\n\n  defmodule Hello do\n\n  end\n\nend\n```\n\nproduces the following AST\n\n``` elixir\n{:defmodule, [line: 1],\n [","ref":"readme.html#module-names-in-the-same-file-must-be-different"},{"type":"extras","title":"This is why it does not work [:Hello] - LazyDoc","doc":"{:__aliases__, [line: 1], [:Hello]},\n   [\n     do: {:defmodule, [line: 3],\n      [\n        {:__aliases__, [line: 3],","ref":"readme.html#this-is-why-it-does-not-work-hello"},{"type":"extras","title":"This is why it does not work [:Hello] - LazyDoc","doc":"[:Hello]},\n        [do: {:__block__, [], []}]\n      ]}\n   ]\n ]}\n```","ref":"readme.html#this-is-why-it-does-not-work-hello"},{"type":"extras","title":"Roadmap - LazyDoc","doc":"- [X] Make AI docs for functions `@doc`.\n- [X] Simple check if the response is in `@doc` format.\n- [X] Make AI providers more extensible (define a behavior, what an AI provider\n  should do ?).\n- [X] Custom path wildcard (limits the action of `lazy_doc`)\n- [X] Make some unit tests.\n- [X] Improve the default prompt to generate markdown syntax.\n- [X] Fix inner module detection (creates scopes for inner modules and builds\n  the full name of the inner module).\n- [X] Make a task or an arg in the current task to check if the functions are\n  documented. (allows CI usage)\n- [X] File is written to file according to Elixir formatter.\n- [X] Make AI docs for modules as well, `@moduledoc`.\n- [X] Custom prompts for function and module.\n- [ ] Simple check if the response is in `@moduledoc` format.\n- [X] Customizable number of retries.\n- [X] Custom paramters to pass the provider (max\\_tokens, top\\_p, temperature).\n- [X] Check if custom paramters are valid for that provider.\n- [ ] Inspect the `defimpl` and `defprotocol` nodes.\n- [ ] Make `@moduledoc` documentation take data from the Modules is related the\n  given module.\n- [ ] Spec mode: Detect if a function does not have any `@specs` and try to\n  generate their specs.\n- [X] Make an option `external_docs` to do `@doc\n  File.read!(\"file_gen_by_lazy_doc.md\")`, this will prevent code redability\n  issues, it will create a folder where all the docs is generated.\n- [X] Make a `mix lazy_doc.clean` task that will allow to clear all the docs for\n  updating to new docs.","ref":"readme.html#roadmap"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}